require "milk_and_cereal/version"

class MilkAndCereal

  def run_on objs, custom_serializer = nil
    @custom_serializer = custom_serializer

    if objs.respond_to? :each
      objs.map do |obj|
        @obj = obj
        serialized_object
      end
    else
      @obj = objs
      serialized_object
    end
  end

  private

    def serialized_object
      serializer.new(@obj).as_json[subvalue]
    end

    def serializer
      @custom_serializer ? @custom_serializer : default_serializer
    end

    def default_serializer
      "#{@obj.class}Serializer".constantize
    end

    def subvalue
      @custom_serializer ? custom_subvalue : default_subvalue
    end

    def default_subvalue
      @obj.class.to_s.underscore
    end

    def custom_subvalue
      @custom_serializer.to_s.underscore.gsub(/_serializer/, '')
    end


end